#pragma once

#define SAFEARRAY(X) SAFEARRAY*
#include "dx7vb.h"
#include "dx8vb.h"

#include "vb.h"

#define __vbaStrToAnsi    (*reinterpret_cast<LPSTR (WINAPI **)(BSTR *, const BSTR)>(0x00401344))
#define __vbaStrToUnicode (*reinterpret_cast<BSTR (WINAPI **)(BSTR *, BSTR)>(0x00401254))
#define __vbaStrCat       (*reinterpret_cast<BSTR (WINAPI **)(const BSTR, const BSTR)>(0x004010D0))
#define __vbaStrCopy      (*reinterpret_cast<BSTR (__fastcall **)(BSTR *, const BSTR)>(0x004012E8))
#define __vbaStrMove      (*reinterpret_cast<BSTR (__fastcall **)(BSTR *, const BSTR)>(0x00401378))
#define __vbaStrCmp       (*reinterpret_cast<int (WINAPI **)(const BSTR, const BSTR)>(0x004011B4))
#define __vbaFreeStr      (*reinterpret_cast<void (__fastcall **)(BSTR *)>(0x004013D4))
#define __vbaObjIs        (*reinterpret_cast<VARIANT_BOOL (WINAPI **)(void *, int)>(0x00401224))
#define __vbaObjSet       (*reinterpret_cast<void * (WINAPI **)(void *, void *)>(0x00401134))
#define __vbaFreeObj      (*reinterpret_cast<void (__fastcall **)(void *)>(0x004013D0))
#define __vbaNew2         (*reinterpret_cast<void (WINAPI **)(void **, IUnknown **)>(0x004012D0))
#define __vbaGet3         (*reinterpret_cast<void (WINAPI **)(DWORD, void *, short)>(0x004011AC))
#define __vbaPut3         (*reinterpret_cast<void (WINAPI **)(DWORD, void *, short)>(0x0040107C))
#define __vbaGet4         (*reinterpret_cast<void (WINAPI **)(DWORD, void *, int, short)>(0x004011C0))
#define __vbaPut4         (*reinterpret_cast<void (WINAPI **)(DWORD, void *, int, short)>(0x0040108C))
#define __vbaFileClose    (*reinterpret_cast<HRESULT (WINAPI **)(short)>(0x00401194))

#define rtcDoEvents     (*reinterpret_cast<void (WINAPI **)()>(0x0040114C))
#define rtcBstrFromAnsi (*reinterpret_cast<BSTR (WINAPI **)(const LPCSTR)>(0x004012B0))
#define rtcErrObj       (*reinterpret_cast<_ErrObject * (WINAPI **)()>(0x00401310))
#define rtcInStrRev     (*reinterpret_cast<int (WINAPI **)(const BSTR, const BSTR, long, long)>(0x00401178))
#define rtcMidCharBstr  (*reinterpret_cast<BSTR (WINAPI **)(const BSTR, long, VARIANT *)>(0x0040117C))
#define rtcFileLength   (*reinterpret_cast<DWORD (WINAPI **)(short)>(0x004012C4))
#define rtcRandomize    (*reinterpret_cast<void (WINAPI **)(VARIANT *)>(0x00401124))
#define rtcFreeVar      (*reinterpret_cast<void (__fastcall **)(VARIANT *)>(0x00401060))

#define mGlobal   (*reinterpret_cast<VBGlobal**>(0x00504F18))
#define mDDraw    (*reinterpret_cast<DirectDraw7**>(0x005011E8))
#define mPrimSurf (*reinterpret_cast<DirectDrawSurface7**>(0x00501508))
#define mDSound   (*reinterpret_cast<DirectSound8**>(0x00503404))

#define mMainFrm (*reinterpret_cast<_Form **>(0x00501024))

#define mDestRect (*reinterpret_cast<RECT *>(0x005010B0))

#define mBGAEnabled (*reinterpret_cast<VARIANT_BOOL *>(0x00502E60))
#define mWindowed   (*reinterpret_cast<VARIANT_BOOL *>(0x005029C8))

#define mReplayMode (*reinterpret_cast<VARIANT_BOOL *>(0x00503448))

#define mTotalRecFrame (*reinterpret_cast<DWORD *>(0x00502D84))

#define mShowPoorBGA   (*reinterpret_cast<VARIANT_BOOL *>(0x0050321C))
#define mShowNormalBGA (*reinterpret_cast<VARIANT_BOOL *>(0x00503008))

#define mBGAID (*reinterpret_cast<long *>(0x00502E60))

#define mSkinBGARect (*reinterpret_cast<RECT *>(0x00501940))


class vbstr_t {
private:
	struct IBSTR {
		__int32 len;
		OLECHAR data[1];
	};

public:
	vbstr_t(BSTR s = NULL, bool peep = false) : m_str(s), m_peep(peep) {}
	vbstr_t(LPCSTR s) {
		size_t len = strlen(s);
		IBSTR *temp = new (_alloca(len + 5)) IBSTR;
		temp->len = len;
		memcpy(temp->data, s, len + 1);

		m_str = NULL;
		m_peep = false;
		__vbaStrToUnicode(&m_str, temp->data);
	}


	~vbstr_t() {
		if(!m_peep && m_str)
			__vbaFreeStr(&m_str);
	}

public:
	BSTR& GetBSTR() {
		return m_str;
	}

	vbstr_t ToAnsi() {
		BSTR ansi;
		__vbaStrToAnsi(&ansi, m_str);
		return vbstr_t(ansi);
	}

	BSTR Detach() {
		BSTR str = m_str;
		m_str = NULL;
		return str;
	}

public:
	operator const char * () {
		return reinterpret_cast<const char *>(m_str);
	}

private:
	BSTR m_str;
	bool m_peep;
};

